% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/catalog.R
\name{uncacheTable}
\alias{uncacheTable}
\alias{uncacheTable.default}
\title{Uncache Table}
\usage{
\method{uncacheTable}{default}(tableName)
}
\arguments{
\item{tableName}{the qualified or unqualified name that designates a table. If no database
identifier is provided, it refers to a table in the current database.}
}
\value{
SparkDataFrame
}
\description{
Removes the specified table from the in-memory cache.
}
\note{
uncacheTable since 1.4.0
}
\examples{
\dontrun{
sparkR.session()
path <- "path/to/file.json"
df <- read.json(path)
createOrReplaceTempView(df, "table")
uncacheTable("table")
}
}
